<?php
/*
Plugin Name: 123 Parameter Check
Description: Überprüft URL-Parameter und setzt ggf. den Status 404. 
Version: 0.10
*/ 
function plw123pck_parse_request( $data )	{
	global $wpdb;
	// Numerische Parameter
	$num_para = array(	'p', 'page_id', 'attachment_id', 'tag_id', 
						'page', 'paged', 
						'year', 'monthnum', 'day', 'w', 'm',
						'hour', 'minute', 'second' );
	// Parameter darf Null sein
	$num_null = array(	'hour', 'minute', 'second' );

	// Parameter übergeben, aber nicht gefunden
	foreach( $_GET as $key => $value )
		if( !array_key_exists( $key, $data->query_vars ) ) {
			$data->query_vars['para_error'] = true;
			$data->query_vars['error'] = '404';
			return;
		}

	// Startseite erzeugt die leeren Parameter pagename und page, das wird akzeptiert 
	if( count($data->query_vars)==2
		&& isset($data->query_vars['pagename']) && isset($data->query_vars['page'])	
		&& ''==$data->query_vars['pagename'] && ''==$data->query_vars['page'] )	{
	  return;
	}

	if( '' == $data->query_vars['page'] )	
		unset( $data->query_vars['page'] );
		
	// Unterseiten bei Artikeln und Seiten prüfen
	if( $data->query_vars['page'] ) { 
		$page_no = ltrim( $data->query_vars['page'], '/' );

		if( $data->query_vars['p'] )
			$post_data = get_post( $data->query_vars['p'] );
		elseif( $data->query_vars['name'] ) {
			$post_name = sanitize_title( $data->query_vars['name'] );
			$post_data = get_post( $wpdb->get_var($wpdb->prepare("SELECT ID FROM $wpdb->posts WHERE post_name = %s", $post_name) ) );
		}
		if( $data->query_vars['page_id'] )
			$post_data = get_page( $data->query_vars['page_id'] );
		elseif( $data->query_vars['pagename'] )
			$post_data = get_page_by_path( $data->query_vars['pagename'] );
			
		if( $post_data ) {
			$np_count = substr_count( $post_data->post_content, '<!--nextpage-->' );
			$np_count++;
			if( $page_no > $np_count || $page_no<=1 )
				$data->query_vars['page'] = 0;	
		}			
	}

	// Numerische Parameter prüfen
	foreach( $data->query_vars as $key => $value ) {
		// Sonderbehandlung Kategorie-IDs
		if( 'cat' == $key ) {
			$test_value = preg_replace( '|[^0-9,-]|', '', $value ); // comma separated list of positive or negative integers
			if( $test_value != $value ) {
				$data->query_vars['para_error'] = true;
				$data->query_vars['error'] = '404';
				return;
			}
		}
		// Numerische Werte
		if( in_array( $key, $num_para ) ) {
			$value = trim( $value );
			// Page bei Einzelansicht (Seite, Artikel) kann führenden Slash enthalten
			if( 'page' == $key )
				$value = ltrim( $value, '/' );
				
			$test_value = absint( $value );
			if( !$test_value && !in_array( $key, $num_null ) ) {
				$data->query_vars['para_error'] = true;
				$data->query_vars['error'] = '404';
				return;
			}
		}
	}
	
}
add_action( 'parse_request', 'plw123pck_parse_request' );
?>